  //
  // Method for processing chat rolls
  //

  function ProcessMessageContent(request)
  {
    TS.dice.putDiceInTray(request, true);
  }
  
  async function handleRollResult(rollEvent) 
  {
	let roll = rollEvent.payload;
	TS.dice.sendDiceResult(roll.resultsGroups, roll.rollId).catch((response) => console.error("error in sending dice result", response));
  }

  //
  // Method for diverting rolls (preventing Pathbuilder rolls and instead running the Talepsire roll code)
  //
  function divertRolls()
  {
	var defaultTab;
	prepareSkillRolls();
    Array.from(document.getElementsByClassName("section-menu")).forEach((el)=>
    {
      if(el.innerHTML=="Weapons") { el.click(); prepareWeaponRolls(); defaultTab = el;}
      if(el.innerHTML=="Spells") { el.click(); prepareSpellRolls(); }
	  if(el.innerHTML=="Pets") { el.click(); prepareCompanionRolls(); }
    });  
	defaultTab.click();
	
	document.getElementById("TalespireLink").innerHTML = "Talespire Rolls Activated";
	setTimeout(()=>{document.getElementById("TalespireLink").innerHTML = "Click <B>Here</B> After Opening Character To Activate Talespire Rolls";},5000);
  }

  //
  // Method for preparing skill or save based rolls
  //
  function prepareSkillRolls()
  {
	document.getElementById("TalespireLink").innerHTML = "Preparing Talespire Skill And Save Rolls";
    Array.from(document.getElementsByClassName("dice-proficiency")).forEach(function(el)
	{
      var els = Array.from(el.parentElement.children);
      els.forEach(function(child) { if(child.className=="section-skill-name") { console.log("PathBuilder-Talespire Link: Skill: "+child.innerHTML); } });
	  el.addEventListener("click", processSkillRolls);
	});
  }

  //
  // Method for processing a skill or save based rolls
  //
  function processSkillRolls(event)
  {
    try
    {
	  console.log("PathBuilder-Talespire Link: Processing Skill Click...");
      var name = "";
      var mod = "";

      if(this.parentElement.className=="section-skill" || this.parentElement.className=="section-skill saves-button")
      {
        var els = Array.from(this.parentElement.children);
        els.forEach(function(child)
        {
          if(child.className=="section-skill-name") { name = child.innerHTML; }
          if(child.className=="section-skill-total") { mod = child.innerHTML; }
        });
		console.log("PathBuilder-Talespire Link: Skill: "+JSON.stringify([{ name: name.trim(), roll: "1D20"+mod.trim() }]));
        ProcessMessageContent([{ name: name.trim(), roll: "1D20"+mod.trim() }]);
      }
    }
    catch(e)
    {
      console.log("PathBuilder-Talespire Link: Error: "+e);
    }
    event.stopPropagation(); 
  }

  //
  // Method for preparing an weapon based rolls
  //
  function prepareWeaponRolls()
  {
	document.getElementById("TalespireLink").innerHTML = "Preparing Talespire Weapon Rolls";
    Array.from(document.getElementsByClassName("mapspan")).forEach(function(el)
	{
      var elx = el;
      while(elx.className!="weapon-container layout-tabbed-line") { elx = elx.parentElement; }
      var txt = elx.innerHTML;
      txt = txt.substring(txt.indexOf("weapon-name"));
      txt = txt.substring(txt.indexOf(">")+1);
      var name = txt.substring(0,txt.indexOf("<"));
	  console.log("PathBuilder-Talespire Link: Weapon: "+name+" ("+el.innerHTML+")");
	  el.addEventListener("click", processWeaponRolls)
	});
  }

  //
  // Method for processing an weapon based rolls
  //
  function processWeaponRolls(event)
  {
    try
    {
      console.log("PathBuilder-Talespire Link: Processing Attack Click...");
      var el = this;
      var attackNum = el.innerHTML;
      while(el.className!="weapon-container layout-tabbed-line") { el = el.parentElement; }
      var txt = el.innerHTML;
      txt = txt.substring(txt.indexOf("weapon-name"));
      txt = txt.substring(txt.indexOf(">")+1);
      var name = txt.substring(0,txt.indexOf("<"));
      txt = txt.substring(txt.indexOf("mapspan"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var attack1 = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      txt = txt.substring(txt.indexOf("mapspan"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var attack2 = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      txt = txt.substring(txt.indexOf("mapspan"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var attack3 = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      txt = txt.substring(txt.indexOf("icon-damage-dice"));
      txt = txt.substring(txt.indexOf("weapon-span"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var damage = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      var attack="";
      if(attackNum=="Attack 1"){attack=attack1;}
      if(attackNum=="Attack 2"){attack=attack2;}
      if(attackNum=="Attack 3"){attack=attack3;}
	  console.log("PathBuilder-Talespire Link: Weapon: "+JSON.stringify([{ name: name.trim()+"(Attack)", roll: "1D20"+attack.trim() },{ name: name.trim()+"(Damage)", roll: damage.trim() }]));
      ProcessMessageContent([{ name: name.trim()+"(Attack)", roll: "1D20"+attack.trim() },{ name: name.trim()+"(Damage)", roll: damage.trim() }]); 
    }
    catch(e)
    {
      console.log("PathBuilder-Talespire Link: Error: "+e);
    }
    event.stopPropagation(); 
  }
  
  //
  // Method for preparing an spell based rolls
  //
  function prepareSpellRolls()
  {
    document.getElementById("TalespireLink").innerHTML = "Preparing Talespire Spell Rolls";
    var elements = Array.from(document.body.getElementsByTagName("*"));
    var spells = [];
    elements.forEach((el)=> { if(el.className.includes("spell-button-row button-text")) { spells.push(el); } });
    spells.forEach(function(el)
	{
	  var name = el.innerHTML;
      name = name.substring(name.indexOf("text-spell"));	  
	  name = name.substring(name.indexOf(">")+1);
	  name = name.substring(0,name.indexOf("<"));
	  if(name!="Not Selected")
	  {
	    console.log("PathBuilder-Talespire Link: Spell: "+name);
	    el.addEventListener("click", ()=>{ setTimeout(processSpellRolls,1000);} ) 
	  }
	});
  };

  //
  // Method for processing an spell based rolls
  //
  function processSpellRolls()
  {
    try
    {
      console.log("PathBuilder-Talespire Link: Processing Spell Click...");
      var el = document.getElementsByClassName("div-listview-info")[0];
      var info = el.innerHTML;
      info = info.substring(info.indexOf("listview-title"));
      info = info.substring(info.indexOf(">")+1);
      var name = info.substring(0,info.indexOf("<"));
      info = info.substring(info.indexOf("listview-detail"));
      var rolls = [];
      while(info.includes("dice-proficiency"))
      {
        if(info.includes("data-roll-value"))
        {
          info = info.substring(info.indexOf("dice-proficiency"));
          info = info.substring(info.indexOf("data-roll-value"));
          info = info.substring(info.indexOf("\"")+1);
          var roll = info.substring(0,info.indexOf("\""));
          if(roll.substring(0,4)=="1d20")
          {
            rolls.push({name: name+"(Attack)", roll: roll});
          }
          else
          {
            rolls.push({name: name+"(Damage)", roll: roll});
          }
        }
        else
        {
          info = "";
        }
      }
 	  console.log("PathBuilder-Talespire Link: Spell: "+JSON.stringify(rolls));
      ProcessMessageContent(rolls);
	  // Uncomment line below to have the spell info page close automatically
	  // modalCancel();
    }
    catch(e)
    {
      console.log("PathBuilder-Talespire Link: Error: "+e);
    }
  };

  //
  // Method for preparing an weapon based rolls
  //
  function prepareCompanionRolls()
  {
	document.getElementById("TalespireLink").innerHTML = "Preparing Talespire Companion Rolls";
    Array.from(document.getElementsByClassName("mapspan")).forEach(function(el)
	{
      var elx = el;
      while(elx.className!="layout-tabbed-line") { elx = elx.parentElement; }
      var txt = elx.innerHTML;
      txt = txt.substring(txt.indexOf("weapon-name"));
      txt = txt.substring(txt.indexOf(">")+1);
      var name = txt.substring(0,txt.indexOf("<"));
	  console.log("PathBuilder-Talespire Link: Companion: "+name+" ("+el.innerHTML+")");
	  el.addEventListener("click", processCompanionRolls)
	});
  }

  //
  // Method for processing an weapon based rolls
  //
  function processCompanionRolls(event)
  {
    try
    {
      console.log("PathBuilder-Talespire Link: Processing Companion Click...");
      var el = this;
      var attackNum = el.innerHTML;
      while(el.className!="layout-tabbed-line") { el = el.parentElement; }
      var txt = el.innerHTML;
      txt = txt.substring(txt.indexOf("weapon-name"));
      txt = txt.substring(txt.indexOf(">")+1);
      var name = txt.substring(0,txt.indexOf("<"));
      txt = txt.substring(txt.indexOf("mapspan"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var attack1 = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      txt = txt.substring(txt.indexOf("mapspan"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var attack2 = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      txt = txt.substring(txt.indexOf("mapspan"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var attack3 = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      txt = txt.substring(txt.indexOf("icon-damage-dice"));
      txt = txt.substring(txt.indexOf("weapon-span"));
      txt = txt.substring(txt.indexOf("</span>")+7);
      var damage = txt.substring(0,txt.indexOf("<")).replace("\"","").replace("\"","");
      var attack="";
      if(attackNum=="Attack 1"){attack=attack1;}
      if(attackNum=="Attack 2"){attack=attack2;}
      if(attackNum=="Attack 3"){attack=attack3;}
  	  console.log("PathBuilder-Talespire Link: Companion: "+JSON.stringify([{ name: name.trim()+"(Attack)", roll: "1D20"+attack.trim() },{ name: name.trim()+"(Damage)", roll: damage.trim() }]));
      ProcessMessageContent([{ name: name.trim()+"(Attack)", roll: "1D20"+attack.trim() },{ name: name.trim()+"(Damage)", roll: damage.trim() }]); 
    }
    catch(e)
    {
      console.log("PathBuilder-Talespire Link: Error: "+e);
    }
    event.stopPropagation(); 
  }
  
  function modalCancel()
  {
    var elements = Array.from(document.getElementsByClassName("modal-button"));
	elements.forEach(function(el)
	{
	  if(el.innerHTML=="Cancel"){ el.click(); }
	});
  };

//
// Divert the rolls after the page has loaded
//
window.addEventListener("load", function() 
{
	let container = document.createElement("span");
    container.id = "TalespireLink";
    container.innerHTML = "Click <B>Here</B> After Opening Character To Activate Talespire Rolls";
	container.onclick = ()=>{ console.log("PathBuilder-Talespire Link: Activating Talespire Rolls..."); divertRolls();}
	container.style = "position: absolute; top: 10px; text-align: right; white-space: nowrap; margin-left: 50%; width: 47%;";
    document.body.appendChild(container);
});